<script lang="ts">
import Vue from 'vue';
import { Accordion } from '../index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';
import { DemoModal } from '~/components/common/index.vue';

export default Vue.extend({
  name: 'BySolutionBenefits',
  components: { Accordion, DemoModal },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    usingGraphic: {
      type: Boolean,
      required: false,
      default: true,
    },
  },
  data() {
    return {
      isOpenIndex: 0 as any,
      modal: false,
    };
  },
  methods: {
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
    openModal() {
      this.modal = true; // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
      // Temporary solution to put nav behind modal when modal is active
      document.querySelector('.nav-hoc').style.zIndex = '0';
    },
    closeModal() {
      this.modal = false;
      // Temporary solution to show nav when modal is inactive
      document.querySelector('.nav-hoc').style.zIndex = '1025';
    },
  },
});
</script>

<template>
  <section :id="data.id" class="by-solution-benefits slp-py-48 slp-py-md-96">
    <SlpContainer>
      <div v-if="usingGraphic">
        <img
          src="https://images.ctfassets.net/xz1dnu24egyd/42bqDPTOCj9fXJrItmsqcV/9b3d71014eb2adce2559664fe353bf89/solutions-common.svg"
          alt=""
        />
      </div>
      <SlpRow v-if="data?.image?.image_url">
        <SlpColumn :cols="8" size="lg">
          <div class="slp-mb-16 slp-mb-md-32">
            <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">
              <span
                :data-aos="data.header_animation"
                :data-aos-duration="data.header_duration"
                >{{ data.title }}</span
              >
            </SlpTypography>
          </div>
        </SlpColumn>
      </SlpRow>

      <SlpRow class="by-solution-benefits__row">
        <SlpColumn :cols="data.is_full_width ? 12 : 6" class="slp-pr-md-16">
          <div v-if="data.video" class="by-solution-benefits__video">
            <lite-vimeo
              ref="video"
              :videoid="
                getVimeoVideoId(createVideoSource(data.video.video_url))
              "
              autoplay
            ></lite-vimeo>
          </div>
          <div
            v-else-if="data?.image?.image_url"
            class="by-solution-benefits__container"
          >
            <img
              class="by-solution-benefits__image"
              :src="data.image.image_url"
              :alt="data.image.alt"
              aria-hidden="true"
              :data-aos="data.left_block_animation"
              :data-aos-duration="data.left_block_duration"
              loading="lazy"
            />
          </div>
          <div v-else class="slp-pb-24">
            <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-16">
              <span
                :data-aos="data.header_animation"
                :data-aos-duration="data.header_duration"
                v-html="$md.render(data.title)"
              ></span>
            </SlpTypography>
            <div
              v-if="data.description"
              class="by-solution-benefits__description"
              v-html="$md.render(data.description)"
            />
            <SlpTypography
              variant="heading5"
              class="slp-mb-16 by-solution-benefits__subcopy"
            >
              <span
                :data-aos="data.header_animation"
                :data-aos-duration="data.header_duration"
                >{{ data.subtitle }}</span
              >
            </SlpTypography>
            <div v-if="data.link && data.link.demo">
              <div @click="openModal">
                <SlpButton
                  v-if="data.link"
                  variant="tertiary"
                  :href="data.link.href"
                  :data-ga-location="data.link.ga_location"
                  :data-ga-name="data.link.ga_name"
                  class="main-cta"
                >
                  {{ data.link.text }}
                  <SlpIcon
                    :variant="data.link?.icon?.variant || 'product'"
                    :name="data.link?.icon?.name || 'chevron-lg-right'"
                /></SlpButton>
              </div>

              <DemoModal
                v-show="modal"
                :data="data.link.demo"
                :visible="modal"
                @close="closeModal"
              />
            </div>
            <SlpButton
              v-else-if="data.link"
              variant="tertiary"
              :href="data.link.href"
              :data-ga-location="data.link.ga_location"
              :data-ga-name="data.link.ga_name"
              class="main-cta"
            >
              {{ data.link.text }}
              <SlpIcon
                :variant="data.link?.icon?.variant || 'product'"
                :name="data.link?.icon?.name || 'chevron-lg-right'"
            /></SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn
          :cols="data.is_full_width ? 12 : 6"
          class="slp-pl-md-16"
          size="lg"
        >
          <div
            :data-aos="data.right_block_animation"
            :data-aos-duration="data.right_block_duration"
          >
            <div
              v-if="data.is_accordion"
              class="by-solution-benefits__items-wrapper"
            >
              <Accordion
                v-for="(item, index) in data.items"
                :key="item.header"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              />
            </div>
            <div v-else class="by-solution-benefits__items-wrapper">
              <div
                v-for="(item, index) in data.items"
                :key="item.header"
                class="slp-pb-16 slp-mb-32"
                :class="{
                  'by-solution-benefits__items-w-border':
                    index !== data.items.length - 1 && data?.bordered,
                }"
              >
                <SlpTypography
                  tag="h3"
                  variant="heading5"
                  class="by-solution-benefits__header"
                >
                  <SlpIcon
                    v-if="item.icon"
                    class="by-solution-benefits__icon"
                    :name="item.icon.name"
                    :alt="item.icon.alt"
                    :variant="item.icon.variant"
                    size="md"
                  />
                  {{ item.header }}
                </SlpTypography>
                <div
                  class="by-solution-benefits__description"
                  v-html="item.text"
                />
                <SlpButton
                  v-if="item.link_url"
                  variant="tertiary"
                  :href="item.link_url"
                  class="cta"
                  :data-ga-name="item?.ga_name"
                  :data-ga-location="item?.ga_location"
                >
                  {{ item.link_text }}
                  <SlpIcon variant="product" name="chevron-lg-right" />
                </SlpButton>
              </div>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.by-solution-benefits {
  position: relative;
  .main-cta {
    margin: $spacing-24 0 $spacing-32;
  }

  .slp-text-heading2-bold:deep .gradient {
    -webkit-text-fill-color: transparent;
    background: linear-gradient(
      94deg,
      #e3995d 8.53%,
      #cb9296 14.9%,
      #7f48d6 95.91%
    );
    -webkit-background-clip: text;
    -moz-background-clip: text;
    background-clip: text;
  }

  .by-solution-benefits__items-wrapper:deep {
    .content {
      color: $color-text-200;
    }

    .slp-btn-tertiary {
      font-size: 14px;
      .slp-icon div {
        height: 13px;
        width: 13px;
      }
    }
  }

  .by-solution-benefits__subcopy {
    display: block;
    @media (min-width: $breakpoint-md) {
      max-width: 83.33%;
    }
  }

  .cta {
    padding-left: $spacing-48;
    margin-top: 28px;
    text-align: left;
  }
  &__row {
    width: 100%;
    word-wrap: break-word;
  }

  &__container {
    position: relative;
    @media (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-48;
    }

    .by-solution-benefits__image {
      max-width: 450px;
      width: 100%;
    }
  }

  &__video {
    position: relative;
    padding: 56.25% 0 0 0;

    lite-vimeo {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }
  }

  &__items-wrapper {
    width: 100%;

    @media (max-width: 1169px) {
      max-width: 100%;
    }
    & > :last-child {
      margin-bottom: 0;
    }
  }

  &__icon {
    margin-right: $spacing-default;
    margin-bottom: 20px;
  }

  &__description {
    color: $color-text-200;

    &:deep {
      p {
        padding-bottom: $spacing-16;
      }
    }
  }

  &__header {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;
    margin-bottom: $spacing-4;
  }

  &__items-w-border {
    border-bottom: 1px solid $color-surface-200;
  }
}
.offset {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
